function [decode]= convDecoder(polGenerator,Rec,k)


%Cuanto vale n, la longitud de palabra cdigo?
n=size(polGenerator,1);

%Cual ser la memoria necesaria(en palabras) para realizar la codificacin, L?
L=size(polGenerator,2)/k;
if (L~=2)
    error('Esta funcin solo acepta un L igual a 2');
end

secuencia = Rec;
%Cuantas palabras recibimos?
nPalabras       = size(secuencia,1);
%Cuantos estados posibles existen?
nEstados        = 2^(k*(L-1));

%Creamos el diagrama de Trellis
%En cada celda almacenaremos una estructura con el estado previo y la
%distancia acumulada
trellis      = cell(nEstados,nPalabras);
trellis0     = cell(nEstados,1);

for i=1:size(trellis,1)
    trellis0{i,1}=struct('estadoPrevio',0,'distanciaAcumulada',0);
    for j=1:size(trellis,2)
        trellis{i,j}=struct('estadoPrevio',0,'distanciaAcumulada',0);
    end
end
%Estructuras de apoyo para manejar datos en decimal y en binario(pero con un bit por cada posicion de la matriz)
secuenciasEstados=cell(nEstados,2);
for i=1:nEstados
    secuenciasEstados{i,1}=i;
    aux =bitget(uint8(i-1), (L-1)*k:-1:1);
    aux = reshape(aux,L-1,k);
    secuenciasEstados{i,2}=aux;    
end
secuenciaPalabras=cell(2^k,2);
for i=1:2^k
    secuenciaPalabras{i,1}=i;
    aux =bitget(uint8(i-1), k:-1:1);
    secuenciaPalabras{i,2}=aux;    
end
%Almacenaremos las palabras codigo que resultan de la transicin
%fila->columna
transiciones=cell(nEstados,nEstados);
for i=1:size(transiciones,1)
    for j=1:size(transiciones,2)
        %CUIDADO, para el caso concreto de L =2
        palabraMensaje = secuenciaPalabras{j,2};
        palabraEstado  = secuenciasEstados{i,2};
        auxmessage=[palabraMensaje;palabraEstado];
        code= convEncoder(polGenerator,auxmessage);
        transiciones{i,j}=code(end-(L-1),:);
    end
end



for i=1:nPalabras    %Para cada palabra codigo recibida
    %Palabra Cadigo:
    y=secuencia(i,:);
    %Inicializamos el trellis anterior
    if (i>1)
        trellisAnterior=[trellis{:,i-1}];
    else
        trellisAnterior=[trellis0{:,1}];
    end
    %Inicializamos que estados son accesibles desde el estado actual y
    %desde cuales puedo llegar al estado actual    
    if i==1
        estadosAccesibles = [1:nEstados];
        accesibleDesde = [1];%CUIDADO,ESTO SOLO PARA L==2
    elseif i == nPalabras
        estadosAccesibles = [1]; %%obligatorio al final
        accesibleDesde  = [1:nEstados];
    else
        estadosAccesibles =  [1:nEstados];
        accesibleDesde  =  [1:nEstados];
    end

    for iDest=1:length(estadosAccesibles)%Para cada estado accesible
        estadoDestino=estadosAccesibles(iDest);
        destado=[];
        for iOrig=1:length(accesibleDesde)%Para cada estado origen
            estadoOrigen=accesibleDesde(iOrig);
            palabraCod  = transiciones{estadoDestino,estadoOrigen};
            d=distanciaHamming(palabraCod,y);
            d=d+trellisAnterior(estadoOrigen).distanciaAcumulada;
            destado=[destado d];%Acumulo las distancias de cada una de las ramas hasta un estado, sumandoles la acumulada
        end      
         [dmin pos]=min(destado);
        estadoOrigenSuper=accesibleDesde(pos);
        %Almaceno el estado origen tal que, su distancia acumulada + la
        %distancia del salto hasta estadoDestino sea mnima
        trellis{estadoDestino,i}.estadoPrevio=estadoOrigenSuper;
        trellis{estadoDestino,i}.distanciaAcumulada=dmin;        
    end
end
%Doy marcha atras para reconstruir la secuencia. Primero en decimal y luego
%en binario
decodeDecimal   = [];
nEstado = 1
for i=size(trellis,2):-1:1
    decodeDecimal = [nEstado decodeDecimal];
    nEstado = trellis{nEstado,i}.estadoPrevio;    
end
decode=[];
for i=1:(length(decodeDecimal)-1)
    decode = [decode;secuenciaPalabras{decodeDecimal(i),2}]
end  